Index: doc/genmodel.py
===================================================================
--- doc/genmodel.py	(revision c094758ad0df0ba9f8a4aa5b788a7c4f1bdf249f)
+++ doc/genmodel.py	(revision 044a9c12e31225b960e033a80e969530db1641d4)
@@ -2,4 +2,5 @@
 import numpy as np
 import matplotlib.pyplot as plt
+import pylab
 sys.path.insert(0, os.path.abspath('..'))
 from sasmodels import generate, core
@@ -28,5 +29,5 @@
     'q_max'     : 1.0,
     'nq'        : 1000,
-    'nq2d'      : 400,
+    'nq2d'      : 100,
     'vmin'      : 1e-3,  # floor for the 2D data results
     'qx_max'    : 0.5,
@@ -59,9 +60,15 @@
     if opts['zscale'] == 'log':
         Iq2D = np.log(np.clip(Iq2D, opts['vmin'], np.inf))
-    h = ax.imshow(Iq2D, interpolation='nearest', aspect=1, origin='upper',
-           extent=[-qx_max, qx_max, -qx_max, qx_max], cmap=ice_cm())
-    # , vmin=vmin, vmax=vmax)
+    ax.imshow(Iq2D, interpolation='nearest', aspect=1, origin='lower',
+        extent=[-qx_max, qx_max, -qx_max, qx_max], cmap=pylab.cm.jet)   
     ax.set_xlabel(r'$Q_x \/(\AA^{-1})$')
     ax.set_ylabel(r'$Q_y \/(\AA^{-1})$')
+
+#            im = self.subplot.imshow(output, interpolation='nearest',
+#                                     origin='lower',
+#                                     vmin=zmin_temp, vmax=self.zmax_2D,
+#                                     cmap=self.cmap,
+#                                     extent=(self.xmin_2D, self.xmax_2D,
+#                                             self.ymin_2D, self.ymax_2D))
 
 def ice_cm():
@@ -97,4 +104,5 @@
     plot_2d(model, opts, ax2d)
     ax1d = fig.add_axes([ax_left, ax_bottom, ax_width, ax_height])
+    plot_1d(model, opts, ax1d)
     #ax.set_aspect('square')
 else:
@@ -121,5 +129,8 @@
 captionstr += '.. figure:: img/' + model_info['id'] + '_autogenfig.png\n'
 captionstr += '\n'
-captionstr += '    1D plot corresponding to the default parameters of the model.\n'
+if model_info['has_2d']:
+    captionstr += '    1D and 2D plots corresponding to the default parameters of the model.\n'
+else:
+    captionstr += '    1D plot corresponding to the default parameters of the model.\n'
 captionstr += '\n'
 
Index: sasmodels/models/core_shell_ellipsoid.c
===================================================================
--- sasmodels/models/core_shell_ellipsoid.c	(revision e7678b2f993854334aca4c45e1c7022b2fdbb509)
+++ sasmodels/models/core_shell_ellipsoid.c	(revision 29172aa52f4fdcefe534e792b14ec43221514fe1)
@@ -8,7 +8,7 @@
           double equat_shell,
           double polar_shell,
-          double core_sld,
-          double shell_sld,
-          double solvent_sld);
+          double sld_core,
+          double sld_shell,
+          double sld_solvent);
 
 
@@ -18,7 +18,7 @@
           double equat_shell,
           double polar_shell,
-          double core_sld,
-          double shell_sld,
-          double solvent_sld,
+          double sld_core,
+          double sld_shell,
+          double sld_solvent,
           double theta,
           double phi);
@@ -40,7 +40,7 @@
           double equat_shell,
           double polar_shell,
-          double core_sld,
-          double shell_sld,
-          double solvent_sld)
+          double sld_core,
+          double sld_shell,
+          double sld_solvent)
 {
 
@@ -51,6 +51,6 @@
     double summ = 0.0;	 //initialize intergral
 
-    const double delpc = core_sld - shell_sld;    //core - shell
-    const double delps = shell_sld - solvent_sld; //shell - solvent
+    const double delpc = sld_core - sld_shell;    //core - shell
+    const double delps = sld_shell - sld_solvent; //shell - solvent
 
     for(int i=0;i<N_POINTS_76;i++) {
@@ -81,7 +81,7 @@
           double equat_shell,
           double polar_shell,
-          double core_sld,
-          double shell_sld,
-          double solvent_sld,
+          double sld_core,
+          double sld_shell,
+          double sld_solvent,
           double theta,
           double phi)
@@ -96,6 +96,6 @@
     const double cyl_y = sin(theta);
 
-    const double sldcs = core_sld - shell_sld;
-    const double sldss = shell_sld- solvent_sld;
+    const double sldcs = sld_core - sld_shell;
+    const double sldss = sld_shell- sld_solvent;
 
     // Compute the angle btw vector q and the
@@ -124,7 +124,7 @@
           double equat_shell,
           double polar_shell,
-          double core_sld,
-          double shell_sld,
-          double solvent_sld)
+          double sld_core,
+          double sld_shell,
+          double sld_solvent)
 {
     double intensity = core_shell_ellipsoid_kernel(q,
@@ -133,7 +133,7 @@
            equat_shell,
            polar_shell,
-           core_sld,
-           shell_sld,
-           solvent_sld);
+           sld_core,
+           sld_shell,
+           sld_solvent);
 
     return intensity;
@@ -146,7 +146,7 @@
           double equat_shell,
           double polar_shell,
-          double core_sld,
-          double shell_sld,
-          double solvent_sld,
+          double sld_core,
+          double sld_shell,
+          double sld_solvent,
           double theta,
           double phi)
@@ -159,7 +159,7 @@
                        equat_shell,
                        polar_shell,
-                       core_sld,
-                       shell_sld,
-                       solvent_sld,
+                       sld_core,
+                       sld_shell,
+                       sld_solvent,
                        theta,
                        phi);
Index: sasmodels/models/core_shell_ellipsoid.py
===================================================================
--- sasmodels/models/core_shell_ellipsoid.py	(revision 5111921153c056b59ff03411e4b7b028d238ae26)
+++ sasmodels/models/core_shell_ellipsoid.py	(revision 29172aa52f4fdcefe534e792b14ec43221514fe1)
@@ -1,5 +1,5 @@
 r"""
 This model provides the form factor, $P(q)$, for a core shell ellipsoid (below)
-where the form factor is normalized by the volume of the cylinder.
+where the form factor is normalized by the volume of the outer [CHECK].
 
 .. math::
@@ -7,5 +7,5 @@
     P(q) = scale * \left<f^2\right>/V + background
 
-where the volume $V = (4/3)\pi(r_{maj}r_{min}^2)$ and the averaging $< >$ is
+where the volume $V = (4/3)\pi(R_{major\_outer}R_{minor\_outer}^2)$ and the averaging $< >$ is
 applied over all orientations for 1D.
 
@@ -22,9 +22,9 @@
 
     P(q) = \frac{scale}{V}\int_0^1
-        \left|F(q,r_{min},r_{max},\alpha)\right|^2d\alpha + background
+        \left|F(q,r_{minor\_core},r_{major\_core},\alpha) + F(q,r_{major\_outer},r_{major\_outer},\alpha)\right|^2d\alpha + background
 
-    \left|F(q,r_{min},r_{max},\alpha)\right|=V\Delta \rho \cdot (3j_1(u)/u)
+    \left|F(q,r_{minor},r_{major},\alpha)\right|=(4\pi/3)r_{major}r_{minor}^2 \Delta \rho \cdot (3j_1(u)/u)
 
-    u = q\left[ r_{maj}^2\alpha ^2 + r_{min}^2(1-\alpha ^2)\right]^{1/2}
+    u = q\left[ r_{major}^2\alpha ^2 + r_{minor}^2(1-\alpha ^2)\right]^{1/2}
 
 where
@@ -43,4 +43,9 @@
 polar core radius, *equat_shell* = $r_{min}$ (or equatorial outer radius),
 and *polar_shell* = $r_{maj}$ (or polar outer radius).
+
+Note:It is the users' responsibility to ensure that shell radii are larger than 
+the core radii, especially if both are polydisperse, in which case the
+core_shell_ellipsoid_xt model may be much better.
+
 
 .. note::
@@ -77,15 +82,16 @@
     single particle scattering amplitude.
     [Parameters]:
-    equat_core = equatorial radius of core,
-    polar_core = polar radius of core,
-    equat_shell = equatorial radius of shell,
-    polar_shell = polar radius (revolution axis) of shell,
-    core_sld = SLD_core
-    shell_sld = SLD_shell
-    solvent_sld = SLD_solvent
+    equat_core = equatorial radius of core, Rminor_core,
+    polar_core = polar radius of core, Rmajor_core,
+    equat_shell = equatorial radius of shell, Rminor_outer,
+    polar_shell = polar radius of shell, Rmajor_outer,
+    sld_core = scattering length density of core,
+    sld_shell = scattering length density of shell,
+    sld_solvent = scattering length density of solvent,
     background = Incoherent bkg
     scale =scale
     Note:It is the users' responsibility to ensure
-    that shell radii are larger than core radii.
+    that shell radii are larger than core radii,
+    especially if both are polydisperse.
     oblate: polar radius < equatorial radius
     prolate :  polar radius > equatorial radius
@@ -97,11 +103,11 @@
 #             ["name", "units", default, [lower, upper], "type", "description"],
 parameters = [
-    ["equat_core",  "Ang",      200,   [0, inf],    "volume",      "Equatorial radius of core"],
-    ["polar_core",  "Ang",       10,   [0, inf],    "volume",      "Polar radius of core"],
-    ["equat_shell", "Ang",      250,   [0, inf],    "volume",      "Equatorial radius of shell"],
-    ["polar_shell", "Ang",       30,   [0, inf],    "volume",      "Polar radius of shell"],
-    ["core_sld",    "1e-6/Ang^2", 2,   [-inf, inf], "",            "Core scattering length density"],
-    ["shell_sld",   "1e-6/Ang^2", 1,   [-inf, inf], "",            "Shell scattering length density"],
-    ["solvent_sld", "1e-6/Ang^2", 6.3, [-inf, inf], "",            "Solvent scattering length density"],
+    ["equat_core",  "Ang",      200,   [0, inf],    "volume",      "Equatorial radius of core, Rminor_core "],
+    ["polar_core",  "Ang",       10,   [0, inf],    "volume",      "Polar radius of core, Rmajor_core"],
+    ["equat_shell", "Ang",      250,   [0, inf],    "volume",      "Equatorial radius of shell, Rminor_outer "],
+    ["polar_shell", "Ang",       30,   [0, inf],    "volume",      "Polar radius of shell, Rmajor_outer"],
+    ["sld_core",    "1e-6/Ang^2", 2,   [-inf, inf], "sld",            "Core scattering length density"],
+    ["sld_shell",   "1e-6/Ang^2", 1,   [-inf, inf], "sld",            "Shell scattering length density"],
+    ["sld_solvent", "1e-6/Ang^2", 6.3, [-inf, inf], "sld",            "Solvent scattering length density"],
     ["theta",       "degrees",    0,   [-inf, inf], "orientation", "Oblate orientation wrt incoming beam"],
     ["phi",         "degrees",    0,   [-inf, inf], "orientation", "Oblate orientation in the plane of the detector"],
@@ -116,7 +122,7 @@
             equat_shell=250.0,
             polar_shell=30.0,
-            core_sld=2.0,
-            shell_sld=1.0,
-            solvent_sld=6.3,
+            sld_core=2.0,
+            sld_shell=1.0,
+            sld_solvent=6.3,
             theta=0,
             phi=0)
@@ -124,7 +130,8 @@
 oldname = 'CoreShellEllipsoidModel'
 
-oldpars = dict(core_sld='sld_core',
-               shell_sld='sld_shell',
-               solvent_sld='sld_solvent',
+oldpars = dict(equat_core='equat_core',polar_core='polar_core',equat_shell='equat_shell',polar_shell='polar_shell',
+               sld_core='sld_core',
+               sld_shell='sld_shell',
+               sld_solvent='sld_solvent',
                theta='axis_theta',
                phi='axis_phi')
@@ -141,7 +148,7 @@
       'equat_shell': 250.0,
       'polar_shell': 30.0,
-      'core_sld': 2.0,
-      'shell_sld': 1.0,
-      'solvent_sld': 6.3,
+      'sld_core': 2.0,
+      'sld_shell': 1.0,
+      'sld_solvent': 6.3,
       'background': 0.001,
       'scale': 1.0,
@@ -155,7 +162,7 @@
       'equat_shell': 54.0,
       'polar_shell': 3.0,
-      'core_sld': 20.0,
-      'shell_sld': 10.0,
-      'solvent_sld': 6.0,
+      'sld_core': 20.0,
+      'sld_shell': 10.0,
+      'sld_solvent': 6.0,
       'background': 0.0,
       'scale': 1.0,
@@ -168,7 +175,7 @@
       'equat_shell': 54.0,
       'polar_shell': 3.0,
-      'core_sld': 20.0,
-      'shell_sld': 10.0,
-      'solvent_sld': 6.0,
+      'sld_core': 20.0,
+      'sld_shell': 10.0,
+      'sld_solvent': 6.0,
       'background': 0.01,
       'scale': 0.01,
Index: sasmodels/models/core_shell_ellipsoid_xt.py
===================================================================
--- sasmodels/models/core_shell_ellipsoid_xt.py	(revision 5111921153c056b59ff03411e4b7b028d238ae26)
+++ sasmodels/models/core_shell_ellipsoid_xt.py	(revision 29172aa52f4fdcefe534e792b14ec43221514fe1)
@@ -1,9 +1,9 @@
 r"""
-An alternative version of $P(q)$ for the core-shell ellipsoid
-(see CoreShellEllipsoidModel), having as parameters the core axial ratio X
-and a shell thickness, which are more often what we would like to determine.
+An alternative version of $P(q)$ for the core_shell_ellipsoid
+having as parameters the core axial ratio X and a shell thickness, 
+which are more often what we would like to determine.
 
 This model is also better behaved when polydispersity is applied than the four
-independent radii in CoreShellEllipsoidModel.
+independent radii in core_shell_ellipsoid model.
 
 Definition
@@ -52,5 +52,5 @@
 ----------
 
-R K Heenan, *Private communication*
+R K Heenan, 2015, reparametrised the core_shell_ellipsoid model
 
 """
@@ -69,10 +69,10 @@
         [Parameters]:
         equat_core = equatorial radius of core,
-        x_core = polar radius of core,
+        x_core = ratio of core polar/equatorial radii,
         t_shell = equatorial radius of outer surface,
-        x_polar_shell = polar radius (revolution axis) of outer surface
-        core_sld = SLD_core
-        shell_sld = SLD_shell
-        solvent_sld = SLD_solvent
+        x_polar_shell = ratio of polar shell thickness to equatorial shell thickness,
+        sld_core = SLD_core
+        sld_shell = SLD_shell
+        sld_solvent = SLD_solvent
         background = Incoherent bkg
         scale =scale
@@ -92,7 +92,7 @@
     ["t_shell",       "Ang",       30,   [0, inf],    "volume",      "Equatorial radius of shell"],
     ["x_polar_shell", "",           1,   [0, inf],    "volume",      "Polar radius of shell"],
-    ["core_sld",      "1e-6/Ang^2", 2,   [-inf, inf], "",            "Core scattering length density"],
-    ["shell_sld",     "1e-6/Ang^2", 1,   [-inf, inf], "",            "Shell scattering length density"],
-    ["solvent_sld",   "1e-6/Ang^2", 6.3, [-inf, inf], "",            "Solvent scattering length density"],
+    ["sld_core",      "1e-6/Ang^2", 2,   [-inf, inf], "",            "Core scattering length density"],
+    ["sld_shell",     "1e-6/Ang^2", 1,   [-inf, inf], "",            "Shell scattering length density"],
+    ["sld_solvent",   "1e-6/Ang^2", 6.3, [-inf, inf], "",            "Solvent scattering length density"],
     ["theta",         "degrees",    0,   [-inf, inf], "orientation", "Oblate orientation wrt incoming beam"],
     ["phi",           "degrees",    0,   [-inf, inf], "orientation", "Oblate orientation in the plane of the detector"],
@@ -108,7 +108,7 @@
             t_shell=30.0,
             x_polar_shell=1.0,
-            core_sld=2.0,
-            shell_sld=1.0,
-            solvent_sld=6.3,
+            sld_core=2.0,
+            sld_shell=1.0,
+            sld_solvent=6.3,
             theta=0,
             phi=0)
@@ -119,7 +119,7 @@
                x_core='X_core',
                t_shell='T_shell',
-               core_sld='sld_core',
-               shell_sld='sld_shell',
-               solvent_sld='sld_solvent',
+               sld_core='sld_core',
+               sld_shell='sld_shell',
+               sld_solvent='sld_solvent',
                theta='axis_theta',
                phi='axis_phi')
@@ -136,7 +136,7 @@
       't_shell': 50.0,
       'x_polar_shell': 0.2,
-      'core_sld': 2.0,
-      'shell_sld': 1.0,
-      'solvent_sld': 6.3,
+      'sld_core': 2.0,
+      'sld_shell': 1.0,
+      'sld_solvent': 6.3,
       'background': 0.001,
       'scale': 1.0,
@@ -150,7 +150,7 @@
       't_shell': 54.0,
       'x_polar_shell': 3.0,
-      'core_sld': 20.0,
-      'shell_sld': 10.0,
-      'solvent_sld': 6.0,
+      'sld_core': 20.0,
+      'sld_shell': 10.0,
+      'sld_solvent': 6.0,
       'background': 0.0,
       'scale': 1.0,
@@ -163,7 +163,7 @@
       't_shell': 54.0,
       'x_polar_shell': 3.0,
-      'core_sld': 20.0,
-      'shell_sld': 10.0,
-      'solvent_sld': 6.0,
+      'sld_core': 20.0,
+      'sld_shell': 10.0,
+      'sld_solvent': 6.0,
       'background': 0.01,
       'scale': 0.01,
Index: sasmodels/resolution.py
===================================================================
--- sasmodels/resolution.py	(revision 17bbadde9de73711781f748816b06e6956dc8cfa)
+++ sasmodels/resolution.py	(revision a146eaab015a1387f12891d14d24aa44e466c81c)
@@ -197,5 +197,6 @@
 
 
-    **Algorithm**
+    Definition
+    ----------
 
     We are using the mid-point integration rule to assign weights to each
@@ -441,5 +442,5 @@
     .. math::
 
-        n_\text{extend} = (n-1) (\log q_\text{max} - \log q_n)
+         n_\text{extend} = (n-1) (\log q_\text{max} - \log q_n)
             / (\log q_n - log q_1)
     """