Index: src/sans/models/media/model_functions.html
===================================================================
--- src/sans/models/media/model_functions.html	(revision a110e37f3899ca055ece7b3152a10cac0ec49e00)
+++ src/sans/models/media/model_functions.html	(revision 9611dd6dddad5e5aece9df9a18152fd8f2db34fc)
@@ -3586,5 +3586,6 @@
 <p>The 1D scattering intensity for this model is calculated according to the equations given by
 Nayuk and Huber (Nayuk, 2012).</p>
-<p>Assuming a hollow parallelepiped with infinitely thin walls, edge lengths <span class="formula"><i>A</i>â
+<p>Assuming a hollow parallelepiped with infinitely thin walls, edge lengths A &le; B &le; C
+	<span class="formula"><i>A</i>â
 â€â
 <i>B</i>â
@@ -3592,6 +3593,6 @@
 <i>C</i></span>
 
-and presenting an orientation with respect to the scattering vector given by Îž and Ï,
-where Îž is the angle between the <em>z</em> axis and the longest axis of the parallelepiped <em>C</em>, and Ï
+and presenting an orientation with respect to the scattering vector given by &theta; and &phi;,
+where &theta; is the angle between the <em>z</em> axis and the longest axis of the parallelepiped <em>C</em>, and &phi;
 is the angle between the scattering vector (lying in the <em>xy</em> plane) and the <em>y</em> axis,
 the form factor is given by:</p>
@@ -3615,7 +3616,7 @@
 <p style="text-align: center;" align="center"><span style="position: relative; top: 6pt;"><img src="img/RectangularHollowPrismInfThinWalls_6.png" alt="" /></span></p>
 
-<p>where <em>V</em> is the volume of the rectangular prism, <span class="formula"><i>Ï</i><sub><span class="mbox">pipe</span></sub></span>
+<p>where <em>V</em> is the volume of the rectangular prism, <span class="formula"><i>&rho;</i><sub><span class="mbox">pipe</span></sub></span>
  is the scattering length of the
-parallelepiped, <span class="formula"><i>Ï</i><sub><span class="mbox">solvent</span></sub></span>
+parallelepiped, <span class="formula"><i>&rho;</i><sub><span class="mbox">solvent</span></sub></span>
  is the scattering length of the solvent, and
 (if the data are in absolute scale) scale represents the volume fraction (which is unitless) .</p>
@@ -3641,5 +3642,5 @@
 </tr>
 <tr><td>short_side</td>
-<td>â«</td>
+<td>&Aring;</td>
 <td>35</td>
 </tr>
@@ -3653,9 +3654,9 @@
 </tr>
 <tr><td>sldPipe</td>
-<td>â«<sup>-2</sup></td>
+<td>&Aring;<sup>-2</sup></td>
 <td>6.3e-6</td>
 </tr>
 <tr><td>sldSolv</td>
-<td>â«<sup>-2</sup></td>
+<td>&Aring;<sup>-2</sup></td>
 <td>1.0e-6</td>
 </tr>
@@ -3697,15 +3698,15 @@
 but the implementation here is closer to the equations given by Nayuk and Huber (Nayuk, 2012).</p>
 <p>The scattering from a massive parallelepiped with an orientation with respect to the scattering vector
-given by Îž and Ï is given by:</p>
+given by &theta; and &phi; is given by:</p>
 
 <p style="text-align: center;" align="center"><span style="position: relative; top: 6pt;"><img src="img/RectangularPrism_1.png" alt="" /></span></p>
 
 <p>where <em>A</em>, <em>B</em> and <em>C</em> are the sides of the parallelepiped and must fulfill <span class="formula"><i>A</i>â
-â€â
+&le;â
 <i>B</i>â
-â€â
+&le;â
 <i>C</i></span>
 ,
-Îž is the angle between the <em>z</em> axis and the longest axis of the parallelepiped <em>C</em>, and Ï
+&theta; is the angle between the <em>z</em> axis and the longest axis of the parallelepiped <em>C</em>, and &phi;
 is the angle between the scattering vector (lying in the <em>xy</em> plane) and the <em>y</em> axis.</p>
 <p>The normalized form factor in 1D is obtained averaging over all possible orientations:</p>
@@ -3717,7 +3718,7 @@
 <p style="text-align: center;" align="center"><span style="position: relative; top: 6pt;"><img src="img/RectangularPrism_3.png" alt="" /></span></p>
 
-<p>where <em>V</em> is the volume of the rectangular prism, <span class="formula"><i>Ï</i><sub><span class="mbox">pipe</span></sub></span>
+<p>where <em>V</em> is the volume of the rectangular prism, <span class="formula"><i>&rho;</i><sub><span class="mbox">pipe</span></sub></span>
  is the scattering length of the
-parallelepiped, <span class="formula"><i>Ï</i><sub><span class="mbox">solvent</span></sub></span>
+parallelepiped, <span class="formula"><i>&rho;</i><sub><span class="mbox">solvent</span></sub></span>
  is the scattering length of the solvent, and
 (if the data are in absolute scale) scale represents the volume fraction (which is unitless) .</p>
@@ -3742,5 +3743,5 @@
 </tr>
 <tr><td>short_side</td>
-<td>â«</td>
+<td>&Aring;</td>
 <td>35</td>
 </tr>
@@ -3754,9 +3755,9 @@
 </tr>
 <tr><td>sldPipe</td>
-<td>â«<sup>-2</sup></td>
+<td>&Aring;<sup>-2</sup></td>
 <td>6.3e-6</td>
 </tr>
 <tr><td>sldSolv</td>
-<td>â«<sup>-2</sup></td>
+<td>&Aring;<sup>-2</sup></td>
 <td>1.0e-6</td>
 </tr>
@@ -3793,5 +3794,5 @@
 <p>The 1D scattering intensity for this model is calculated by forming the difference of the
 amplitudes of two massive parallelepipeds differing in their outermost dimensions in
-each direction by the same length increment 2 Î (Nayuk, 2012).</p>
+each direction by the same length increment 2 &Delta; (Nayuk, 2012).</p>
 <p>As in the case of the massive parallelepiped, the scattering amplitude is computed for a particular
 orientation of the parallelepiped with respect to the scattering vector and then averaged over all
@@ -3800,5 +3801,5 @@
 <p style="text-align: center;" align="center"><span style="position: relative; top: 6pt;"><img src="img/RectangularHollowPrism_1.png" alt="" /></span></p>
 
-<p>where Îž is the angle between the <em>z</em> axis and the longest axis of the parallelepiped, Ï
+<p>where &theta; is the angle between the <em>z</em> axis and the longest axis of the parallelepiped, &phi;
 is the angle between the scattering vector (lying in the <em>xy</em> plane) and the <em>y</em> axis, and:</p>
 
@@ -3806,7 +3807,7 @@
 
 <p>where <em>A</em>, <em>B</em> and <em>C</em> are the external sides of the parallelepiped fulfilling <span class="formula"><i>A</i>â
-â€â
+&le;â
 <i>B</i>â
-â€â
+&le;â
 <i>C</i></span>
 ,
@@ -3819,7 +3820,7 @@
 <p style="text-align: center;" align="center"><span style="position: relative; top: 6pt;"><img src="img/RectangularHollowPrism_4.png" alt="" /></span></p>
 
-<p>where <span class="formula"><i>Ï</i><sub><span class="mbox">pipe</span></sub></span>
+<p>where <span class="formula"><i>&rho;</i><sub><span class="mbox">pipe</span></sub></span>
  is the scattering length of the
-parallelepiped, <span class="formula"><i>Ï</i><sub><span class="mbox">solvent</span></sub></span>
+parallelepiped, <span class="formula"><i>&rho;</i><sub><span class="mbox">solvent</span></sub></span>
  is the scattering length of the solvent, and
 (if the data are in absolute scale) scale represents the volume fraction (which is unitless) .</p>
@@ -3845,5 +3846,5 @@
 </tr>
 <tr><td>short_side</td>
-<td>â«</td>
+<td>&Aring;</td>
 <td>35</td>
 </tr>
@@ -3857,13 +3858,13 @@
 </tr>
 <tr><td>thickness</td>
-<td>â«</td>
+<td>&Aring;</td>
 <td>1</td>
 </tr>
 <tr><td>sldPipe</td>
-<td>â«<sup>-2</sup></td>
+<td>&Aring;<sup>-2</sup></td>
 <td>6.3e-6</td>
 </tr>
 <tr><td>sldSolv</td>
-<td>â«<sup>-2</sup></td>
+<td>&Aring;<sup>-2</sup></td>
 <td>1.0e-6</td>
 </tr>