Index: sasmodels/models/barbell.py
===================================================================
--- sasmodels/models/barbell.py	(revision 9b79f2966c4083a48b4894b6bf0587bef7a5be09)
+++ sasmodels/models/barbell.py	(revision 9802ab3945a154b871264715dcb463d4ec644afa)
@@ -68,5 +68,5 @@
 The 2D scattering intensity is calculated similar to the 2D cylinder model.
 
-.. figure:: img/cylinder_angle_definition.jpg
+.. figure:: img/cylinder_angle_definition.png
 
     Definition of the angles for oriented 2D barbells.
Index: sasmodels/models/capped_cylinder.py
===================================================================
--- sasmodels/models/capped_cylinder.py	(revision 9b79f2966c4083a48b4894b6bf0587bef7a5be09)
+++ sasmodels/models/capped_cylinder.py	(revision 9802ab3945a154b871264715dcb463d4ec644afa)
@@ -71,5 +71,5 @@
 The 2D scattering intensity is calculated similar to the 2D cylinder model.
 
-.. figure:: img/cylinder_angle_definition.jpg
+.. figure:: img/cylinder_angle_definition.png
 
     Definition of the angles for oriented 2D cylinders.
Index: sasmodels/models/core_shell_bicelle.py
===================================================================
--- sasmodels/models/core_shell_bicelle.py	(revision 9b79f2966c4083a48b4894b6bf0587bef7a5be09)
+++ sasmodels/models/core_shell_bicelle.py	(revision 9802ab3945a154b871264715dcb463d4ec644afa)
@@ -63,9 +63,10 @@
 cylinders is then given by integrating over all possible $\theta$ and $\phi$.
 
-The *theta* and *phi* parameters are not used for the 1D output.
+For oriented bicelles the *theta*, and *phi* orientation parameters will appear when fitting 2D data, 
+see the :ref:`cylinder` model for further information.
 Our implementation of the scattering kernel and the 1D scattering intensity
 use the c-library from NIST.
 
-.. figure:: img/cylinder_angle_definition.jpg
+.. figure:: img/cylinder_angle_definition.png
 
     Definition of the angles for the oriented core shell bicelle model,
Index: sasmodels/models/core_shell_bicelle_elliptical.py
===================================================================
--- sasmodels/models/core_shell_bicelle_elliptical.py	(revision 9b79f2966c4083a48b4894b6bf0587bef7a5be09)
+++ sasmodels/models/core_shell_bicelle_elliptical.py	(revision 9802ab3945a154b871264715dcb463d4ec644afa)
@@ -76,5 +76,5 @@
 bicelles is then given by integrating over all possible $\alpha$ and $\psi$.
 
-For oriented bicellles the *theta*, *phi* and *psi* orientation parameters only appear when fitting 2D data, 
+For oriented bicelles the *theta*, *phi* and *psi* orientation parameters will appear when fitting 2D data, 
 see the :ref:`elliptical-cylinder` model for further information.
 
Index: sasmodels/models/core_shell_ellipsoid.py
===================================================================
--- sasmodels/models/core_shell_ellipsoid.py	(revision 9b79f2966c4083a48b4894b6bf0587bef7a5be09)
+++ sasmodels/models/core_shell_ellipsoid.py	(revision 9802ab3945a154b871264715dcb463d4ec644afa)
@@ -77,4 +77,6 @@
    F^2(q)=\int_{0}^{\pi/2}{F^2(q,\alpha)\sin(\alpha)d\alpha}
 
+For oriented ellipsoids the *theta*, *phi* and *psi* orientation parameters will appear when fitting 2D data, 
+see the :ref:`elliptical-cylinder` model for further information.
 
 References
Index: sasmodels/models/cylinder.py
===================================================================
--- sasmodels/models/cylinder.py	(revision 9b79f2966c4083a48b4894b6bf0587bef7a5be09)
+++ sasmodels/models/cylinder.py	(revision 9802ab3945a154b871264715dcb463d4ec644afa)
@@ -61,7 +61,10 @@
 .. _cylinder-angle-definition:
 
-.. figure:: img/cylinder_angle_definition.jpg
+.. figure:: img/cylinder_angle_definition.png
 
-    Definition of the angles for oriented cylinders.
+    Definition of the $\theta$ and $\phi$ orientation angles for a cylinder relative 
+    to the beam line coordinates, plus an indication of their orientation distributions 
+    which are described as rotations about each of the perpendicular axes $\delta_1$ and $\delta_2$ 
+    in the frame of the cylinder itself, which when $\theta = \phi = 0$ are parallel to the $Y$ and $X$ axes.
 
 .. figure:: img/cylinder_angle_projection.png
@@ -69,5 +72,10 @@
     Examples for oriented cylinders.
 
-The $\theta$ and $\phi$ parameters only appear in the model when fitting 2d data.
+The $\theta$ and $\phi$ parameters to orient the cylinder only appear in the model when fitting 2d data. 
+On introducing "Orientational Distribution" in the angles, "distribution of theta" and "distribution of phi" parameters will
+appear. These are actually rotations about the axes $\delta_1$ and $\delta_2$ of the cylinder, which when $\theta = \phi = 0$ are parallel 
+to the $Y$ and $X$ axes of the instrument respectively. Some experimentation may be required to understand the 2d patterns fully.
+(Earlier implementations had numerical integration issues in some circumstances when orientation distributions passed through 90 degrees, such 
+situations, with very broad distributions, should still be approached with care.) 
 
 Validation
Index: sasmodels/models/elliptical_cylinder.py
===================================================================
--- sasmodels/models/elliptical_cylinder.py	(revision 9b79f2966c4083a48b4894b6bf0587bef7a5be09)
+++ sasmodels/models/elliptical_cylinder.py	(revision 9802ab3945a154b871264715dcb463d4ec644afa)
@@ -57,7 +57,5 @@
 define the axis of the cylinder using two angles $\theta$, $\phi$ and $\Psi$
 (see :ref:`cylinder orientation <cylinder-angle-definition>`). The angle
-$\Psi$ is the rotational angle around its own long_c axis against the $q$ plane.
-For example, $\Psi = 0$ when the $r_\text{minor}$ axis is parallel to the
-$x$ axis of the detector.
+$\Psi$ is the rotational angle around its own long_c axis. 
 
 All angle parameters are valid and given only for 2D calculation; ie, an
@@ -66,6 +64,6 @@
 .. figure:: img/elliptical_cylinder_angle_definition.png
 
-    Definition of angles for oriented elliptical cylinder, where axis_ratio >1,
-    and angle $\Psi$ is a rotation around the axis of the cylinder.
+    Definition of angles for oriented elliptical cylinder, where axis_ratio is drawn >1,
+    and angle $\Psi$ is now a rotation around the axis of the cylinder.
 
 .. figure:: img/elliptical_cylinder_angle_projection.png
@@ -73,4 +71,12 @@
     Examples of the angles for oriented elliptical cylinders against the
     detector plane, with $\Psi$ = 0.
+
+The $\theta$ and $\phi$ parameters to orient the cylinder only appear in the model when fitting 2d data. 
+On introducing "Orientational Distribution" in the angles, "distribution of theta" and "distribution of phi" parameters will
+appear. These are actually rotations about the axes $\delta_1$ and $\delta_2$ of the cylinder, the $b$ and $a$ axes of the 
+cylinder cross section. (When $\theta = \phi = 0$ these are parallel to the $Y$ and $X$ axes of the instrument.) 
+The third orientation distribution, in $\psi$, is about the $c$ axis of the particle. Some experimentation may be required to 
+understand the 2d patterns fully. (Earlier implementations had numerical integration issues in some circumstances when orientation 
+distributions passed through 90 degrees, such situations, with very broad distributions, should still be approached with care.) 
 
 NB: The 2nd virial coefficient of the cylinder is calculated based on the
Index: sasmodels/models/parallelepiped.py
===================================================================
--- sasmodels/models/parallelepiped.py	(revision 3401a7aceb5cdc0b93fdbf24a3dff56293273a3a)
+++ sasmodels/models/parallelepiped.py	(revision 9802ab3945a154b871264715dcb463d4ec644afa)
@@ -112,4 +112,12 @@
     detector plane.
 
+On introducing "Orientational Distribution" in the angles, "distribution of theta" and "distribution of phi" parameters will
+appear. These are actually rotations about axes $\delta_1$ and $\delta_2$ of the parallelepiped, perpendicular to the $a$ x $c$ and $b$ x $c$ faces. 
+(When $\theta = \phi = 0$ these are parallel to the $Y$ and $X$ axes of the instrument.) The third orientation distribution, in $\psi$, is 
+about the $c$ axis of the particle, perpendicular to the $a$ x $b$ face. Some experimentation may be required to 
+understand the 2d patterns fully. (Earlier implementations had numerical integration issues in some circumstances when orientation 
+distributions passed through 90 degrees, such situations, with very broad distributions, should still be approached with care.) 
+
+    
 For a given orientation of the parallelepiped, the 2D form factor is
 calculated as
Index: sasmodels/models/stacked_disks.py
===================================================================
--- sasmodels/models/stacked_disks.py	(revision 9b79f2966c4083a48b4894b6bf0587bef7a5be09)
+++ sasmodels/models/stacked_disks.py	(revision 9802ab3945a154b871264715dcb463d4ec644afa)
@@ -77,5 +77,5 @@
 the axis of the cylinder using two angles $\theta$ and $\varphi$.
 
-.. figure:: img/cylinder_angle_definition.jpg
+.. figure:: img/cylinder_angle_definition.png
 
     Examples of the angles against the detector plane.
Index: sasmodels/models/triaxial_ellipsoid.py
===================================================================
--- sasmodels/models/triaxial_ellipsoid.py	(revision 3401a7aceb5cdc0b93fdbf24a3dff56293273a3a)
+++ sasmodels/models/triaxial_ellipsoid.py	(revision 9802ab3945a154b871264715dcb463d4ec644afa)
@@ -76,7 +76,6 @@
     of the particle.
 
-The angle $\psi$ is the rotational angle around its own $c$ axis
-against the $q$ plane. For example, $\psi = 0$ when the
-$a$ axis is parallel to the $x$ axis of the detector.
+For oriented ellipsoids the *theta*, *phi* and *psi* orientation parameters will appear when fitting 2D data, 
+see the :ref:`elliptical-cylinder` model for further information.
 
 .. _triaxial-ellipsoid-angles: