Index: build_tools/jenkins_linux_build.sh
===================================================================
--- build_tools/jenkins_linux_build.sh	(revision 9f15df44d88ddbd4e2b4d0b6422dfaee400e9c56)
+++ build_tools/jenkins_linux_build.sh	(revision 9939b1603283b7b9a863d258a9b0e17efc66c378)
@@ -15,5 +15,8 @@
 rm -rf build
 
-export PYTHONPATH=$PYTHONPATH:$WORKSPACE/sasview-install:$WORKSPACE/utils
+"$EASY_INSTALL" -d "$WORKSPACE/utils" bumps==0.7.5
+"$EASY_INSTALL" -d "$WORKSPACE/utils" periodictable==1.3.0
+
+export PYTHONPATH=$WORKSPACE/sasview-install:$WORKSPACE/utils:$PYTHONPATH
 
 $PYTHON check_packages.py
Index: build_tools/jenkins_linux_pylint.sh
===================================================================
--- build_tools/jenkins_linux_pylint.sh	(revision 57986a193b4c99f3eed011b3e03a3994511e3545)
+++ build_tools/jenkins_linux_pylint.sh	(revision 9939b1603283b7b9a863d258a9b0e17efc66c378)
@@ -1,3 +1,4 @@
 #! /bin/sh
+set -x
 
 # try to find reasonable settings, if not provided in the environment
@@ -8,8 +9,8 @@
 # WORKSPACE top level of source
 
-export PYTHONPATH=$PYTHONPATH:$WORKSPACE/sasview-install:$WORKSPACE/utils
+export PYTHONPATH=$WORKSPACE/sasview-install:$WORKSPACE/utils:$PYTHONPATH
 
 cd $WORKSPACE
 rm -f test/*.txt
 
-$PYLINT --rcfile $WORKSPACE/build_tools/pylint.rc -f parseable sasview-install/sasview.egg/sans sansview > test/sansview.txt || exit 0
+$PYLINT --rcfile "$WORKSPACE/build_tools/pylint.rc" -f parseable sasview-install/sasview.egg/sans sansview > test/sansview.txt || exit 0
Index: build_tools/jenkins_rhel6_build.sh
===================================================================
--- build_tools/jenkins_rhel6_build.sh	(revision 5709051a16febce00b286288e9681dc40db38534)
+++ build_tools/jenkins_rhel6_build.sh	(revision 9939b1603283b7b9a863d258a9b0e17efc66c378)
@@ -12,4 +12,8 @@
 export SASVIEW_INSTALL=sasview-install
 
+if [ -z "$EASY_INSTALL" ]; then
+	EASY_INSTALL=`which easy_install`
+fi
+
 
 # Set up build environmentRun tests #######################################
@@ -21,7 +25,9 @@
 fi
 export PYTHONPATH=$PYTHONPATH:$WORKSPACE/utils
-easy_install -d $WORKSPACE/utils unittest-xml-reporting
-easy_install -d $WORKSPACE/utils lxml
-easy_install -d $WORKSPACE/utils pyparsing==1.5.5
+"$EASY_INSTALL" -d "$WORKSPACE/utils" unittest-xml-reporting
+"$EASY_INSTALL" -d "$WORKSPACE/utils" lxml
+"$EASY_INSTALL" -d "$WORKSPACE/utils" pyparsing==1.5.5
+"$EASY_INSTALL" -d "$WORKSPACE/utils" bumps==0.7.5
+"$EASY_INSTALL" -d "$WORKSPACE/utils" periodictable==1.3.0
 python deps.py
 
Index: check_packages.py
===================================================================
--- check_packages.py	(revision 443a4870bb5ec4dd2d2c1de6c45fc938d3952934)
+++ check_packages.py	(revision 9939b1603283b7b9a863d258a9b0e17efc66c378)
@@ -5,26 +5,32 @@
 import sys
 
-common_required_package_list = {'setuptools':{'version':'0.6c11','import_name':'setuptools','test':'__version__'},
-                'pyparsing':{'version':'1.5.5','import_name':'pyparsing','test':'__version__'},
-                'html5lib':{'version':'0.95','import_name':'html5lib','test':'__version__'},
-                'reportlab':{'version':'2.5','import_name':'reportlab','test':'Version'},
-                'lxml':{'version':'2.3','import_name':'lxml.etree','test':'LXML_VERSION'},
-                'PIL':{'version':'1.1.7','import_name':'Image','test':'VERSION'},
-                'pylint':{'version':None,'import_name':'pylint','test':None},
-                'periodictable':{'version':'1.3.0','import_name':'periodictable','test':'__version__'},
-                'numpy':{'version':'1.6.1','import_name':'numpy','test':'__version__'},
-                'scipy':{'version':'0.10.1','import_name':'scipy','test':'__version__'},
-                'wx':{'version':'2.8.12.1','import_name':'wx','test':'__version__'},
-                'matplotlib':{'version':'1.1.0','import_name':'matplotlib','test':'__version__'},
-                'pisa':{'version':'3.0.28','import_name':'ho.pisa','test':'__version__'}
+common_required_package_list = {
+    'setuptools':{'version':'0.6c11','import_name':'setuptools','test':'__version__'},
+    'pyparsing':{'version':'1.5.5','import_name':'pyparsing','test':'__version__'},
+    'html5lib':{'version':'0.95','import_name':'html5lib','test':'__version__'},
+    'reportlab':{'version':'2.5','import_name':'reportlab','test':'Version'},
+    'lxml':{'version':'2.3','import_name':'lxml.etree','test':'LXML_VERSION'},
+    'PIL':{'version':'1.1.7','import_name':'Image','test':'VERSION'},
+    'pylint':{'version':None,'import_name':'pylint','test':None},
+    'periodictable':{'version':'1.3.0','import_name':'periodictable','test':'__version__'},
+    'bumps':{'version':'0.7.5','import_name':'periodictable','test':'__version__'},
+    'numpy':{'version':'1.6.1','import_name':'numpy','test':'__version__'},
+    'scipy':{'version':'0.10.1','import_name':'scipy','test':'__version__'},
+    'wx':{'version':'2.8.12.1','import_name':'wx','test':'__version__'},
+    'matplotlib':{'version':'1.1.0','import_name':'matplotlib','test':'__version__'},
+    'pisa':{'version':'3.0.28','import_name':'ho.pisa','test':'__version__'},
+}
+win_required_package_list = {
+    'comtypes':{'version':'0.6.2','import_name':'comtypes','test':'__version__'},
+    'pywin':{'version':'217','import_name':'pywin','test':'__version__'},
+    'py2exe':{'version':'0.6.9','import_name':'py2exe','test':'__version__'},
+}
+mac_required_package_list = {
+    'py2app':{'version':None,'import_name':'py2app','test':'__version__'},
+}
 
+deprecated_package_list = {
+    'pyPdf':{'version':'1.13','import_name':'pyPdf','test':'__version__'},
 }
-win_required_package_list = {'comtypes':{'version':'0.6.2','import_name':'comtypes','test':'__version__'},
-                             'pywin':{'version':'217','import_name':'pywin','test':'__version__'},
-                             'py2exe':{'version':'0.6.9','import_name':'py2exe','test':'__version__'}
-}
-mac_required_package_list = {'py2app':{'version':None,'import_name':'py2app','test':'__version__'}}
-
-deprecated_package_list = {'pyPdf':{'version':'1.13','import_name':'pyPdf','test':'__version__'}}
 
 print "Checking Required Package Versions...."